Puzzles(概率dp)(图)

2023-10-25 04:32
文章标签 dp 概率 puzzles

本文主要是介绍Puzzles(概率dp)(图),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

                                             D. Puzzles

Barney lives in country USC (United States of Charzeh). USC has n cities numbered from 1 through n and n - 1 roads between them. Cities and roads of USC form a rooted tree (Barney's not sure why it is rooted). Root of the tree is the city number 1. Thus if one will start his journey from city 1, he can visit any city he wants by following roads.

                                                                             

Some girl has stolen Barney's heart, and Barney wants to find her. He starts looking for in the root of the tree and (since he is Barney Stinson not a random guy), he uses a random DFS to search in the cities. A pseudo code of this algorithm is as follows:

let starting_time be an array of length n
current_time = 0
dfs(v):current_time = current_time + 1starting_time[v] = current_timeshuffle children[v] randomly (each permutation with equal possibility)// children[v] is vector of children cities of city vfor u in children[v]:dfs(u)

As told before, Barney will start his journey in the root of the tree (equivalent to call dfs(1)).

Now Barney needs to pack a backpack and so he wants to know more about his upcoming journey: for every city i, Barney wants to know the expected value of starting_time[i]. He's a friend of Jon Snow and knows nothing, that's why he asked for your help.

Input

The first line of input contains a single integer n (1 ≤ n ≤ 105) — the number of cities in USC.

The second line contains n - 1 integers p2, p3, ..., pn (1 ≤ pi < i), where pi is the number of the parent city of city number i in the tree, meaning there is a road between cities numbered pi and i in USC.

Output

In the first and only line of output print n numbers, where i-th number is the expected value of starting_time[i].

Your answer for each city will be considered correct if its absolute or relative error does not exceed 10 - 6.

Examples

input

Copy

7
1 2 1 1 4 4

output

Copy

1.0 4.0 5.0 3.5 4.5 5.0 5.0 

input

Copy

12
1 1 2 2 4 4 3 3 1 10 8

output

Copy

1.0 5.0 5.5 6.5 7.5 8.0 8.0 7.0 7.5 6.5 7.5 8.0 

 

题意:给出每个节点的父节点,构成了一张图。从1出发,使用题目代码中的走法(即为dfs),问你从1到每一个点的期望值。

思路:

分析一颗子树:

                                                                

当前已知节点1的期望为1.0 ->anw[1]=1.0

需要通过节点1递推出节点2、4、5的期望值

1的儿子分别是2、4、5,那么dfs序所有可能的排列是6种:

1:1-2-4-5  (2、4、5节点的儿子没有写出)

2:1-2-5-4

3:1-4-2-5

4:1-4-5-2

5:1-5-2-4

6:1-5-4-2

计算节点2的期望值得时候,当节点2的前面已经排列了num个点,那么节点2的dfs序就要增加num

所以anw[2]的计算分为两部分,第一部分是:anw[2]=anw[1]+1  (节点1通过1步直接到达儿子2、4、5)

第二部分是:当节点1到达节点2的时候贡献是0,种类分别对应(1、2)

      当先到达节点4后到节点2的时候贡献(size(4)+size(4)+szie(5)),种类分别对应(3、4)

      当先到达节点5后到节点2的时候贡献(size(5)+size(5)+size(4)),种类分别对应(5、6)

而所有的排列对于的概率都是1/6,所以第二部分的贡献就是(0+size(4)*3+size(5)*3)/6 = (size(4)+size(5))/2

仔细推理几颗子树之后:发现anw[v]=anw[u]+1.0+(sz[u]-sz[v]-1)/2.0。

anw[u]+1.0对应第一部分  (sz[u]-sz[v]-1)/2.0 表示的是当前能排在节点v前面的u的儿子的总数  *  0.5

对比1-6的6种排列,任意儿子a、b  ,满足a在b前面的概率是0.5  

来源:https://blog.csdn.net/libin66/article/details/51918509

每个兄弟节点在自己前面走的概率都是0.5,而一个节点所有的兄弟节点个数为son[a]-son[s[a][i]]-1,乘以0.5即为在自己之前的期望。

#include<bits/stdc++.h>
#define in(a) scanf("%d",&a)
using namespace std;
vector<int> s[100005];
int son[100005];
double ans[100005];void dfs(int a)
{int len=s[a].size();son[a]=len;for(int i=0;i<len;i++){dfs(s[a][i]);son[a]+=son[s[a][i]];}
}void cal(int a)
{int len=s[a].size();for(int i=0;i<len;i++){ans[s[a][i]]=ans[a]+1+0.5*(son[a]-son[s[a][i]]-1);cal(s[a][i]);}
}int main()
{int T,t;in(T);for(int i=1;i<=T;i++)s[i].clear();for(int i=2;i<=T;i++){in(t);s[t].push_back(i);}dfs(1);ans[1]=1.0;cal(1);for(int i=1;i<=T;i++)printf("%.8f ",ans[i]);puts("");return 0;}

 

这篇关于Puzzles(概率dp)(图)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/280044

相关文章

hdu4826(三维DP)

这是一个百度之星的资格赛第四题 题目链接:http://acm.hdu.edu.cn/contests/contest_showproblem.php?pid=1004&cid=500 题意:从左上角的点到右上角的点,每个点只能走一遍,走的方向有三个:向上,向下,向右,求最大值。 咋一看像搜索题,先暴搜,TLE,然后剪枝,还是TLE.然后我就改方法,用DP来做,这题和普通dp相比,多个个向上

hdu1011(背包树形DP)

没有完全理解这题, m个人,攻打一个map,map的入口是1,在攻打某个结点之前要先攻打其他一个结点 dp[i][j]表示m个人攻打以第i个结点为根节点的子树得到的最优解 状态转移dp[i][ j ] = max(dp[i][j], dp[i][k]+dp[t][j-k]),其中t是i结点的子节点 代码如下: #include<iostream>#include<algorithm

hdu4865(概率DP)

题意:已知前一天和今天的天气概率,某天的天气概率和叶子的潮湿程度的概率,n天叶子的湿度,求n天最有可能的天气情况。 思路:概率DP,dp[i][j]表示第i天天气为j的概率,状态转移如下:dp[i][j] = max(dp[i][j, dp[i-1][k]*table2[k][j]*table1[j][col] )  代码如下: #include <stdio.h>#include

usaco 1.1 Broken Necklace(DP)

直接上代码 接触的第一道dp ps.大概的思路就是 先从左往右用一个数组在每个点记下蓝或黑的个数 再从右到左算一遍 最后取出最大的即可 核心语句在于: 如果 str[i] = 'r'  ,   rl[i]=rl[i-1]+1, bl[i]=0 如果 str[i] = 'b' ,  bl[i]=bl[i-1]+1, rl[i]=0 如果 str[i] = 'w',  bl[i]=b

uva 10154 DP 叠乌龟

题意: 给你几只乌龟,每只乌龟有自身的重量和力量。 每只乌龟的力量可以承受自身体重和在其上的几只乌龟的体重和内。 问最多能叠放几只乌龟。 解析: 先将乌龟按力量从小到大排列。 然后dp的时候从前往后叠,状态转移方程: dp[i][j] = dp[i - 1][j];if (dp[i - 1][j - 1] != inf && dp[i - 1][j - 1] <= t[i]

uva 10118 dP

题意: 给4列篮子,每次从某一列开始无放回拿蜡烛放入篮子里,并且篮子最多只能放5支蜡烛,数字代表蜡烛的颜色。 当拿出当前颜色的蜡烛在篮子里存在时,猪脚可以把蜡烛带回家。 问最多拿多少只蜡烛。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cs

uva 10069 DP + 大数加法

代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <stack>#include <vector>#include <queue>#include <map>#include <cl

uva 10029 HASH + DP

题意: 给一个字典,里面有好多单词。单词可以由增加、删除、变换,变成另一个单词,问能变换的最长单词长度。 解析: HASH+dp 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#inc

XTU 1233 n个硬币连续m个正面个数(dp)

题面: Coins Problem Description: Duoxida buys a bottle of MaiDong from a vending machine and the machine give her n coins back. She places them in a line randomly showing head face or tail face o

dp算法练习题【8】

不同二叉搜索树 96. 不同的二叉搜索树 给你一个整数 n ,求恰由 n 个节点组成且节点值从 1 到 n 互不相同的 二叉搜索树 有多少种?返回满足题意的二叉搜索树的种数。 示例 1: 输入:n = 3输出:5 示例 2: 输入:n = 1输出:1 class Solution {public int numTrees(int n) {int[] dp = new int